﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=9.3
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: True
	#StartCommandReturnValue: android.app.Service.START_STICKY
#End Region
'#StartCommandReturnValue: android.app.Service.START_STICKY
'	#ExcludeFromLibrary: True
'	#StartAtBoot: True
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Private myftp As FTP
	Private FirstBo As Boolean
	Private uid As Int
	Dim saveDir As String
End Sub

Sub Service_Create
	'Service.AutomaticForegroundMode = Service.AUTOMATIC_FOREGROUND_ALWAYS  'we are handling it ourselves	
	Service.AutomaticForegroundMode = Service.AUTOMATIC_FOREGROUND_NEVER
	'Service.AutomaticForegroundMode = Service.AUTOMATIC_FOREGROUND_WHEN_NEEDED
	Dim ctxt As JavaObject
	ctxt.InitializeContext
	uid = ctxt.RunMethodJO("getApplicationInfo", Null).GetField("uid")
	Log(uid)
	FirstBo = True
	saveDir = File.DirRootExternal & "/Test"
	If File.Exists(saveDir,"")=False Then
		File.MakeDir(File.DirRootExternal,"Test")
		Filescan(File.DirRootExternal,"")
	End If
End Sub

Sub Service_Start (StartingIntent As Intent)	
	Log(DateTime.Now)
	Service.StartForeground(uid,CreateNotification("...."))
	'Service.AutomaticForegroundNotification = CreateNotification("....")	
	Dim L As Long
	If FirstBo = False Then 
		WriteLog("",False,"","Service.txt","now")
		myftp.Initialize("myftp", "my ip",21, "User", "PassWord")
		myftp.PassiveMode = True
		myftp.TimeoutMs = 30
		myftp.SendCommand("NOOP","")
		Wait For myftp_CommandCompleted ( Command As String, Success As Boolean, ReplyCode As Int, ReplyString As String)		
		If ReplyCode = 200 Then
			DateTime.DateFormat = "yyyyMMddHHmmss"
			'myftp.UploadFile(File.DirRootExternal & "/Test","service.txt",True,"service_" & DateTime.Date(DateTime.Now) & ".txt")
			myftp.UploadFile(File.DirRootExternal & "/Test","service.txt",True,"service.txt")
			Log(Success)
		End If
	End If
	If FirstBo = True Then
		NextStart(60,10)
		FirstBo = False
	Else
		NextStart(60,10)
	End If
	Sleep(1)
	'Service.StopAutomaticForeground 'Call this when the background task completes (if there is one)
	'Service.StopForeground(uid)
End Sub

Sub Service_Destroy
	WriteLog("",False,"","ServiceTM.txt","A" & DateTime.Now)
	Log("a")
End Sub

Private Sub GetStartTime(HHmmss As String) As Long
	Dim Dateformat As String = DateTime.Dateformat
	Dim Timeformat As String = DateTime.Timeformat
	Dim Now As Long = DateTime.now
	DateTime.Dateformat = "yyyy/MM/dd"
	Dim StartDate As String = DateTime.Date(Now)
	Dim StartDatelng As Long = DateTime.DateTimeParse(StartDate,HHmmss)
	If 	StartDatelng < Now Then
		Dim AddPeriod As Period
		AddPeriod.Initialize
		AddPeriod.Days = 1
		StartDatelng = DateUtils.AddPeriod(StartDatelng, AddPeriod)
	End If
	DateTime.Dateformat = Dateformat
	DateTime.Timeformat = Timeformat
	Return StartDatelng
End Sub

Sub NextStart(DoIntvSec As Long, Xsec As Long)
	Dim L As Long
	Dim Dateformat As String = DateTime.Dateformat
	L = GetNextDoTime(DoIntvSec)
	DateTime.Dateformat = "yyyy/MM/dd HH:mm:ss"
	Log(DateTime.Date(L))
	DateTime.Dateformat = Dateformat
	StartServiceAt(Me, L, True)
End Sub

Private Sub GetNextDoTime(DoIntvSec As Long) As Long
'	'GetNextDoTime = DateAdd("s", ((DateDiff("s", "1980/1/1", Now) \ DoIntvSec) + 1) * DoIntvSec, "1980/1/1")
	Dim Dateformat As String = DateTime.Dateformat
	Dim Timeformat As String = DateTime.Timeformat
	DateTime.Dateformat = "yyyy/MM/HH HH:mm:ss"
	Dim Now As Long = DateTime.Now
	Dim P As Period
	P = DateUtils.PeriodBetweenInDays(DateTime.DateParse("1980/01/01 00:00:00"),Now)
	Dim PTotalSec As Long = P.Days * 86400 + P.Hours * 3600 + P.Minutes * 60
	Dim PP As Long = (Floor(PTotalSec / DoIntvSec) + 1 ) * DoIntvSec
	Dim P2 As Period
	P2.Initialize
	P2.Seconds = PP
	DateUtils.AddPeriod(DateTime.DateParse("1980/01/01 00:00:00"),P2)
	Return DateUtils.AddPeriod(DateTime.DateParse("1980/01/01 00:00:00"),P2)
	Log(DateTime.Date(DateUtils.AddPeriod(DateTime.DateParse("1980/01/01 00:00:00"),P2)))
	'Sub PeriodBetweenInDays (now, EndTime As Long) As Period
	'Dim DiffSec
	DateTime.Dateformat = Dateformat
	DateTime.Timeformat = Timeformat
End Sub

Public Sub WriteLog(DirName As String,DateDirBol As Boolean,SubDirName As String,FileName As String,WriteStr As String)
	Try
		DateTime.Dateformat = "yyyyMM"
		Dim DateStr As String = ""
		If DirName <> "" Then DirName= "/" & DirName
		If DateDirBol=True Then DateStr = "/" & DateTime.Date(DateTime.Now)
		If SubDirName <> "" Then SubDirName= "/" & SubDirName
		Dim AllDirName As String = saveDir  & DirName & DateStr & SubDirName
		If File.Exists(AllDirName,"") =False Then File.MakeDir(saveDir,DirName & DateStr & SubDirName)
		Dim outStream As OutputStream
		Dim txtWrite As TextWriter
		outStream = File.OpenOutput(AllDirName,FileName,True)
		txtWrite.Initialize2(outStream,"BIG5")    '編碼
		DateTime.Dateformat = "yyyy/MM/dd HH:mm:ss"
		DateStr = DateTime.Date(DateTime.Now)
		txtWrite.WriteLine(DateStr & "," & WriteStr & Chr(13))
		txtWrite.Flush
		txtWrite.Close
		outStream.Close
		Filescan(AllDirName,FileName)
	Catch
		Log("WriteLog")
	End Try
End Sub

Public Sub Filescan(dir As String,filename As String)	'快速顯示
	Try
		Dim context As JavaObject
		context = context.InitializeStatic("anywheresoftware.b4a.BA").GetField("applicationContext")
		Dim paths() As String = Array As String(File.Combine(dir,filename)) 'files to scan
		Dim mediaScanner As JavaObject
		mediaScanner.InitializeStatic("android.media.MediaScannerConnection")
		mediaScanner.RunMethod("scanFile", Array As Object(context, paths, Null, Null))
	Catch
		WriteLog("Error",True,"","FileIO.log",LastException.Message)
		Log(LastException)
	End Try
End Sub

Sub CreateNotification (Body As String) As Notification
	Dim notification As Notification
	notification.Initialize2(notification.IMPORTANCE_MIN)
	notification.Icon = "icon"
	notification.Sound = False
	notification.Vibrate = False
	notification.AutoCancel = True
	'notification.SetInfo("Tracking location", Body,Main)
	notification.SetInfo("Tracking location", Body,Main)
	notification.Notify(uid)
	'notification.Cancel(uid)
	Return notification	
End Sub